import 'dart:convert';
import 'dart:developer';
import 'dart:collection';
import 'dart:developer';

import 'package:easynetflutter/easynet/log/Logger.dart';
import 'package:shared_preferences/shared_preferences.dart';

class SessionDataBase {

  static Logger logger = Logger(className: "SessionDataBase");
  static Map<String, dynamic> mapSessionName = Map();
  static clearSession() {
    if (mapSessionName !=  null && mapSessionName.length > 0) {
      mapSessionName.forEach((k,v) => removeObject(k));
      mapSessionName.clear();
    }
  }


  static Future<String> getObject(String sessionName) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    String data = prefs.getString(sessionName);
    if (data != null) {
      logger.w("obtendo objeto $sessionName : $data ");
      return data;
    } else {
      return null;
    }
  }

  static removeObjectMap(String sessionName) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.remove(sessionName);
    logger.w("removendo objeto $sessionName");
  }

  static removeObject(String sessionName) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.remove(sessionName);
    logger.w("removendo objeto $sessionName");
    if (mapSessionName.containsKey(sessionName) ) {
      mapSessionName.remove(sessionName);
    }
  }

  static Future saveOject(Object value, String sessionName) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    String jsonStr = jsonEncode(value);
    prefs.setString(sessionName, jsonStr);
    logger.w("salvando objeto $value " + value.toString());
  }

  static Future saveString(String sessionName, String value) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setString(sessionName, value);
  }

  static Future saveInt(String sessionName, int value) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setInt(sessionName, value);
  }

  static Future saveBool(String sessionName, bool value) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setBool(sessionName, value);
  }

  static Future saveDouble(String sessionName, double value) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setDouble(sessionName, value);
  }

  static Future saveListString(String sessionName, List<String> value) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setStringList(sessionName, value);
  }
}