import 'package:flutter/material.dart';
//typedef FormFieldValidator<T> = String Function(T value);
typedef SeletecOption<String> = String Function(String value);

class DialogComponent extends StatelessWidget {
  const DialogComponent({@required BuildContext this.context, @required this.title, @required this.content, @required this.buttonText, this.selectedOption });

  final BuildContext context;
  final String title;
  final String content;
  final String buttonText;
  final SeletecOption<String> selectedOption;


  Widget build(BuildContext context) {
    return getDialog();
  }

  getDialog() {
    List<String> buttons = buttonText.split(",");
    return AlertDialog(
      title: new Text(title),
      content: new Text(content),
      actions: buttons.map<Widget>((String bntText) {
        return new FlatButton(
          child: new Text(bntText),
          onPressed: () {

            if (this.selectedOption != null) {
              if ("FECHAR".toUpperCase() == bntText.toUpperCase()) {
                Navigator.of(context).pop();
              }
              this.selectedOption(bntText);
            } else {
              if ("FECHAR".toUpperCase() == bntText.toUpperCase()) {
                Navigator.of(context).pop();
              }
            }
          },
        );
      }).toList()

    );
  }
}